osg::ShaderBinary Class Reference

`#include <Shader>`

Inheritance diagram for osg::ShaderBinary:

## Public Member Functions

| ShaderBinary ()
| ShaderBinary (const ShaderBinary &rhs, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osg, ShaderBinary)
void | allocate (unsigned int size)
void | assign (unsigned int size, const unsigned char *data)
unsigned int | getSize () const
unsigned char * | getData ()
const unsigned char * | getData () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Static Public Member Functions

static ShaderBinary * | readShaderBinaryFile (const std::string &fileName)
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Protected Types

typedef std::vector< unsigned char > | Data

## Protected Attributes

Data | _data
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Detailed Description

Simple class for wrapping up the data used in OpenGL ES 2's glShaderBinary calls. ShaderBinary is set up with the binary data then assigned to one or more osg::Shader.

## Member Typedef Documentation

## Data

typedef std::vector<unsigned char> osg::ShaderBinary::Data

protected

## Constructor & Destructor Documentation

## ShaderBinary() [1/2]

osg::ShaderBinary::ShaderBinary | ( |  | ) |

Referenced by META_Object(), readShaderBinaryFile(), and ShaderBinary().

## ShaderBinary() [2/2]

osg::ShaderBinary::ShaderBinary | ( | const ShaderBinary & | rhs,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

Copy constructor using CopyOp to manage deep vs shallow copy.

References ShaderBinary(), and osg::CopyOp::SHALLOW_COPY.

## Member Function Documentation

## allocate()

void osg::ShaderBinary::allocate | ( | unsigned int | size | ) |

Allocated a data buffer of specified size.

## assign()

void osg::ShaderBinary::assign | ( | unsigned int | size,
|  | const unsigned char * | data )

Assign shader binary data, copying the specified data into locally stored data buffer, the original data can then be deleted.

## getData() [1/2]

unsigned char * osg::ShaderBinary::getData | ( |  | ) |

inline

Get a ptr to the shader binary data.

References _data.

## getData() [2/2]

const unsigned char * osg::ShaderBinary::getData | ( |  | ) | const

inline

Get a const ptr to the shader binary data.

References _data.

## getSize()

unsigned int osg::ShaderBinary::getSize | ( |  | ) | const

inline

Get the size of the shader binary data.

References _data.

## META_Object()

osg::ShaderBinary::META_Object | ( | osg | ,
|  | ShaderBinary | )

References ShaderBinary().

## readShaderBinaryFile()

ShaderBinary * osg::ShaderBinary::readShaderBinaryFile | ( | const std::string & | fileName | ) |

static

Read shader binary from file. Return the resulting Shader or 0 if no valid shader binary could be read.

References ShaderBinary().

## Member Data Documentation

## _data

Data osg::ShaderBinary::_data

protected

Referenced by getData(), getData(), and getSize().

The documentation for this class was generated from the following file:

- Shader